#include "camera.h"
#include "render.h"

Camera g_camera;

void camera_init() {
    g_camera.centre = ZeroVector;
    g_camera.width = 10;
}

static inline
float _camera_height(Camera* self) {
    return self->width * ((float)g_render_resolution.y / (float)g_render_resolution.x);
}

static inline
float _one() {
    return g_render_resolution.x / g_camera.width;
}

SDL_FRect camera_world_to_screen_space(Camera* self, SDL_FRect* world_space) {
    float unit = _one();
    return (SDL_FRect) {
        .x = (world_space->x - g_camera.centre.x + g_camera.width/2.0) * unit,
        .y = (world_space->y - g_camera.centre.y + _camera_height(&g_camera)/2.0) * unit,
        .w = world_space->w * unit,
        .h = world_space->h * unit
    };
}

SDL_FRect camera_calculate_unit_rect() {
    // If the camera's width is 1, this rectangle should fill the width of the screen.
    // If the camera's width is 2, this rectangle should fill half the width of the screen.
    float unit = _one();
    return (SDL_FRect) {
        .x = (-g_camera.centre.x + g_camera.width/2) * unit,
        .y = (-g_camera.centre.y + _camera_height(&g_camera)/2) * unit,
        .w = unit,
        .h = unit
    };
}
