#ifndef _fencer_program_h
#define _fencer_program_h

#include <SDL2/SDL.h>
#include <SDL2/SDL_render.h>
#include "vmath.h"
#include "render.h"

struct ProgramSettings {
    const char* title;
    IVector view_resolution;
    int target_fps;
};

extern SDL_Window* g_window;
extern double g_delta_time;
extern double g_frame_start;

extern int program_run(const struct ProgramSettings* settings);
extern void program_quit();
extern void program_handle_events();
extern void program_handle_windowevent(SDL_WindowEvent* event);

#endif // !_fencer_program_h
